package onlinePrint.com.frame;

package ..deTemp.1735190406293;

import entrance.utils.Code;
import europeCodePrint.com.djzhao.db.OracleUtils;
import governorBranch.db.OracleUtils;
import java.awt.AWTException;
import java.awt.Color;
import java.awt.Component;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.event.ItemListener;
import java.awt.event.MouseListener;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;
import onlinePrint.com.data.SourceData;
import onlinePrint.com.data.V7Model;
import onlinePrint.com.factory.PrinterSet;
import onlinePrint.com.factory.SynchronousPrintSet;
import onlinePrint.com.factory.TablePanel;
import onlinePrint.com.frame.OnlineCodePrintMain;
import onlinePrint.com.model.Hanger;
import onlinePrint.com.util.CodeAndPrint;
import onlinePrint.com.util.Loading;
import onlinePrint.com.util.OracledbUtil;
import onlinePrint.com.util.ViewChangeUtil;
import onlinePrint.com.util.WaitUtil;
import org.apache.commons.lang.StringUtils;

public class ComponentCodePrint extends JPanel {
  GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
  
  Rectangle rect = this.ge.getMaximumWindowBounds();
  
  int width = this.rect.width;
  
  int height = this.rect.height;
  
  public static boolean iswndl = false;
  
  public static boolean istype_B = false;
  
  public TablePanel scrollPane;
  
  public PrinterSet print_setting;
  
  public JButton btnNewButton1;
  
  public JButton btnNewButton2;
  
  public JButton btnCreate;
  
  public JButton btnPrintSearch;
  
  public boolean isShowOM = false;
  
  public boolean guajian = false;
  
  public boolean btnCreate_CLICKED = false;
  
  public boolean btnPrintSearch_CLICKED = false;
  
  public JScrollPane pane2;
  
  public static String[] iteminfo = new String[8];
  
  final CodeAndPrint codeprinter = new CodeAndPrint();
  
  public static String printname;
  
  public static int fontsize = 8;
  
  public JButton synchronizationBtn;
  
  public JCheckBox whetherSynchronization;
  
  private Robot robot = null;
  
  private boolean screen = false;
  
  String ts = "";
  
  private String[] title = new String[] { 
      "请选择", "编号", "计划完成时间", "班次", "产线", "优先级", "计划备注", "客户描述", "项目号", "T物料描述", 
      "销售订单号", "销售订单行", "S物料号", "S物料描述", "安排数量", "状态" };
  
  ResultSet set;
  
  ResultSet detailset;
  
  int[][] mapper;
  
  private String sDesc = null;
  
  String table1sql = "";
  
  private List<Hanger> generalBoxList = new ArrayList<>();
  
  private boolean haveortherT = true;
  
  private boolean refuseCreate = false;
  
  private ArrayList<V7Model> v7List = null;
  
  private boolean isInitializedV7 = false;
  
  private SourceData sourceData = new SourceData();
  
  private List<Hanger> list = new ArrayList<>();
  
  ArrayList<String> printDataList = null;
  
  String printnameSelect = "Microsoft Print to PDF";
  
  WaitUtil waitUtil = null;
  
  private JTextField textField_time;
  
  private JTextField textField_1;
  
  private JTextField textField_orno;
  
  private JTextField textField_pono;
  
  private JTextField textField_cprj;
  
  private JButton btn_ornoSearch;
  
  private JButton btn_flush;
  
  private JLabel productionLine_label;
  
  private JComboBox productionLine_comboBox;
  
  private SynchronousPrintSet synchronousPrintSet;
  
  private JComboBox comboBox;
  
  private ViewChangeUtil changeview;
  
  private String stations;
  
  private String printFlag = "";
  
  public Loading loading;
  
  List<String> aList = Arrays.asList(new String[] { "AU", "EU", "MY", "OT" });
  
  List<String> bList = Arrays.asList(new String[] { "1", "3", "EN81-20", "EN81-70", "EN81-71", "EN81-72" });
  
  private List<Hanger> printList = new ArrayList<>();
  
  public ComponentCodePrint(OnlineCodePrintMain frame) {
    this.loading = new Loading("正在生成数据，请稍后");
    this.loading.setBounds(0, 0, 1400, 900);
    this.loading.start();
    this.loading.setVisible(false);
    add((Component)this.loading);
    JLabel label_orno = new JLabel("订单号:");
    label_orno.setVisible(false);
    label_orno.setBounds(522, 25, 50, 15);
    add(label_orno);
    try {
      this.robot = new Robot();
    } catch (AWTException e) {
      e.printStackTrace();
    } 
    this.textField_orno = new JTextField();
    this.textField_orno.setVisible(false);
    this.textField_orno.setBounds(573, 25, 128, 21);
    this.textField_orno.setColumns(10);
    add(this.textField_orno);
    JLabel label_pono = new JLabel("订单行:");
    label_pono.setVisible(false);
    label_pono.setBounds(710, 25, 50, 15);
    add(label_pono);
    this.textField_pono = new JTextField();
    this.textField_pono.setVisible(false);
    this.textField_pono.setBounds(760, 25, 128, 21);
    this.textField_pono.setColumns(10);
    add(this.textField_pono);
    JLabel label_cprj = new JLabel("项目号:");
    label_cprj.setVisible(false);
    label_cprj.setBounds(898, 25, 50, 15);
    add(label_cprj);
    this.textField_cprj = new JTextField();
    this.textField_cprj.setVisible(false);
    this.textField_cprj.setBounds(948, 25, 128, 21);
    this.textField_cprj.setColumns(10);
    add(this.textField_cprj);
    this.btn_flush = new JButton("刷新");
    this.btn_flush.setBounds(1080, 23, 80, 21);
    add(this.btn_flush);
    this.btn_ornoSearch = new JButton("搜索");
    this.btn_ornoSearch.setVisible(false);
    this.btn_ornoSearch.setBounds(1173, 23, 80, 21);
    add(this.btn_ornoSearch);
    JLabel lblNewLabel = new JLabel("打印进度:");
    lblNewLabel.setBounds(580, (int)(this.height * 0.79D) + 45, 64, 15);
    add(lblNewLabel);
    JProgressBar progressBar = new JProgressBar();
    progressBar.setBounds(651, (int)(this.height * 0.79D) + 45, 157, 23);
    progressBar.setStringPainted(true);
    progressBar.setString("暂无打印任务!");
    add(progressBar);
    JLabel disposableLabel = new JLabel("可打印数量:");
    disposableLabel.setBounds(818, (int)(this.height * 0.79D) + 45, 70, 15);
    add(disposableLabel);
    JTextField disposableText = new JTextField();
    disposableText.setBounds(894, (int)(this.height * 0.79D) + 45, 80, 15);
    add(disposableText);
    JLabel arrangeLabel = new JLabel("安排数量:");
    arrangeLabel.setBounds(985, (int)(this.height * 0.79D) + 45, 55, 15);
    add(arrangeLabel);
    JTextField arrangeText = new JTextField();
    arrangeText.setBounds(1046, (int)(this.height * 0.79D) + 45, 80, 15);
    add(arrangeText);
    JLabel label_date = new JLabel("生产日期:");
    label_date.setBounds(20, 27, 64, 15);
    add(label_date);
    this.textField_time = new JTextField();
    Date date = new Date();
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    String nowtime = sdf.format(date);
    this.textField_time.setText(nowtime);
    this.textField_time.setEditable(false);
    this.textField_time.setBounds(82, 25, 104, 21);
    add(this.textField_time);
    this.textField_time.setColumns(10);
    JLabel labelTime = new JLabel("班次:");
    labelTime.setBounds(204, 25, 54, 15);
    add(labelTime);
    this.comboBox = new JComboBox();
    this.comboBox.setBounds(235, 25, 107, 21);
    add(this.comboBox);
    this.productionLine_label = new JLabel("产线:");
    this.productionLine_label.setBounds(358, 25, 54, 21);
    add(this.productionLine_label);
    this.productionLine_comboBox = new JComboBox();
    this.productionLine_comboBox.setBounds(397, 25, 107, 21);
    add(this.productionLine_comboBox);
    this.stations = Code.USER.getProductionJurisdiction();
    System.out.println("输出绑定的工位：  " + this.stations);
    String jointT = "";
    if (this.stations != null && !this.stations.equals("")) {
      String[] pArr = this.stations.split(",");
      for (int j = 0; j < pArr.length; j++)
        jointT = jointT + "'" + pArr[j] + "',"; 
      this.stations = jointT.substring(0, jointT.length() - 1);
    } 
    String shifts = "";
    if ("root".equals(Code.USER.getProduction())) {
      shifts = "select distinct SHIFTS  from CBARCODE_ONLINEPLAN where   to_char(PRODUCTION_DATE,'yyyy-mm-dd')='" + nowtime + "'";
    } else {
      shifts = "select distinct SHIFTS  from CBARCODE_ONLINEPLAN where   to_char(PRODUCTION_DATE,'yyyy-mm-dd')='" + nowtime + "' and PRODUCTION_LINE='" + Code.USER.getProduction() + "'";
    } 
    System.out.println(shifts);
    this.changeview = new ViewChangeUtil();
    this.changeview.upDateComboBoxWIBLACK(shifts, this.comboBox, "SHIFTS");
    if (StringUtils.isNotBlank(Code.USER.getProduct())) {
      String product = " ," + Code.USER.getProduct();
      String[] products = product.split(",");
      this.productionLine_comboBox.setModel(new DefaultComboBoxModel<>(products));
    } else {
      String[] strarr = { " " };
      this.productionLine_comboBox.setModel(new DefaultComboBoxModel<>(strarr));
    } 
    JTable table1 = new JTable();
    table1.setRowHeight(30);
    DefaultTableCellRenderer tcr = new DefaultTableCellRenderer();
    tcr.setHorizontalAlignment(0);
    table1.setDefaultRenderer(Object.class, tcr);
    table1.setAutoResizeMode(0);
    Object object1 = new Object(this, (Object[][])null, (Object[])this.title);
    table1.setModel((TableModel)object1);
    TableColumn tableColumn = table1.getColumn("状态");
    Object object2 = new Object(this);
    tableColumn.setCellRenderer((TableCellRenderer)object2);
    table1.getTableHeader().setReorderingAllowed(false);
    RowSorter<TableModel> sorter = new TableRowSorter(object1);
    table1.setRowSorter(sorter);
    table1.setSelectionMode(2);
    table1.getColumnModel().getColumn(0).setCellRenderer((TableCellRenderer)new Object(this));
    String table1Init = "";
    String productText = this.productionLine_comboBox.getSelectedItem().toString();
    if (StringUtils.isNotBlank(productText)) {
      table1Init = "select ID,to_char(PRODUCTION_DATE,'yyyy-mm-dd') as PRODUCTION_DATE,SHIFTS,PRODUCT,SERIALNUMBER,REMARKS,CUSTOMER_DESC,PROJECT_NUMBER,T_ITEM_DESC,SO_NUMBER,SO_LINE,S_ITEM,S_ITEM_DESC,QUANTITY,FINISH_STATUS from CBARCODE_ONLINEPLAN where   to_char(PRODUCTION_DATE,'yyyy-mm-dd')='" + nowtime + "' ORDER BY FINISH_STATUS, SERIALNUMBER ASC";
    } else {
      table1Init = "select ID,to_char(PRODUCTION_DATE,'yyyy-mm-dd') as PRODUCTION_DATE,SHIFTS,PRODUCT,SERIALNUMBER,REMARKS,CUSTOMER_DESC,PROJECT_NUMBER,T_ITEM_DESC,SO_NUMBER,SO_LINE,S_ITEM,S_ITEM_DESC,QUANTITY,FINISH_STATUS from CBARCODE_ONLINEPLAN where   to_char(PRODUCTION_DATE,'yyyy-mm-dd')='" + nowtime + "' ";
      table1Init = operaSql(table1Init) + "ORDER BY FINISH_STATUS, SERIALNUMBER ASC";
    } 
    System.out.println("表格初始化数据sql：" + table1Init);
    OracledbUtil outil = new OracledbUtil();
    this.set = outil.ExecuteSQL(table1Init);
    this.changeview = new ViewChangeUtil();
    Object[][] data = this.changeview.flushQueryTableNew(this.set);
    if (data != null) {
      object1.setRowCount(0);
      for (Object[] o : data)
        object1.addRow(o); 
    } else {
      JOptionPane.showMessageDialog(null, "查询失败!", "Message", 0);
    } 
    outil.close();
    this.comboBox.addItemListener((ItemListener)new Object(this, (DefaultTableModel)object1));
    this.productionLine_comboBox.addItemListener((ItemListener)new Object(this, (DefaultTableModel)object1));
    String pj = Code.USER.getPrintJurisdiction();
    System.out.println("输出工位绑定的大类：  " + pj);
    jointT = "";
    String[] tArr = pj.split(",");
    for (int i = 0; i < tArr.length; i++)
      jointT = jointT + "'" + tArr[i] + "',"; 
    jointT = jointT.substring(0, jointT.length() - 1);
    this.ts = " and t in(" + jointT + ")";
    if (this.ts == null || this.ts == "") {
      JOptionPane.showMessageDialog(null, "无法获取数据,请先绑定大类", "Message", 0);
      return;
    } 
    System.out.println("输出工位绑定的大类：  " + this.ts);
    this.btn_flush.addMouseListener((MouseListener)new Object(this, (DefaultTableModel)object1, progressBar));
    this.btn_ornoSearch.addMouseListener((MouseListener)new Object(this));
    this.textField_time.addMouseListener((MouseListener)new Object(this, frame, (DefaultTableModel)object1));
    setBackground(Color.WHITE);
    setLayout(null);
    this.scrollPane = new TablePanel((Object[][])null);
    this.scrollPane.setBounds(560, (int)(this.height * 0.49D) + 25, 700, (int)(this.height * 0.3D));
    add((Component)this.scrollPane);
    this.btnCreate = new JButton("生成");
    this.btnCreate.setVisible(false);
    this.btnCreate.setBounds(1100, (int)(this.height * 0.49D) + 25 + 34 - 75, 120, 29);
    add(this.btnCreate);
    this.btnPrintSearch = new JButton("备库挂件");
    this.btnPrintSearch.setVisible(false);
    this.btnPrintSearch.setBounds(900, (int)(this.height * 0.49D) + 25 + 34 - 75, 120, 29);
    add(this.btnPrintSearch);
    this.print_setting = new PrinterSet("printername0");
    this.print_setting.setBounds(20, (int)(this.height * 0.49D) + 25 + 34, 512, 273);
    add((Component)this.print_setting);
    JButton closeBtn = new JButton("展开设置");
    closeBtn.setBounds(420, (int)(this.height * 0.49D) + 25, 101, 29);
    add(closeBtn);
    closeBtn.addMouseListener((MouseListener)new Object(this, closeBtn));
    this.synchronousPrintSet = new SynchronousPrintSet();
    this.synchronousPrintSet.setBounds(20, (int)(this.height * 0.49D) + 25 + 34, 512, 273);
    this.synchronousPrintSet.setVisible(false);
    add((Component)this.synchronousPrintSet);
    this.synchronizationBtn = new JButton("展开同步打印设置");
    this.synchronizationBtn.setBounds(260, (int)(this.height * 0.49D) + 25, 150, 29);
    add(this.synchronizationBtn);
    this.synchronizationBtn.addMouseListener((MouseListener)new Object(this, closeBtn));
    this.whetherSynchronization = new JCheckBox("是否开启同步打印");
    this.whetherSynchronization.setBackground(Color.WHITE);
    this.whetherSynchronization.setSelected(true);
    this.whetherSynchronization.setBounds(100, (int)(this.height * 0.49D) + 25, 150, 23);
    add(this.whetherSynchronization);
    this.btnNewButton2 = new JButton("打印");
    this.btnNewButton2.setBounds(1147, (int)(this.height * 0.79D) + 45, 93, 23);
    add(this.btnNewButton2);
    this.pane2 = new JScrollPane();
    this.pane2.setBounds(20, 60, 1210, (int)(this.height * 0.49D) - 40 - 50);
    this.pane2.setViewportView(table1);
    add(this.pane2);
    System.out.println("输出工位绑定的大类：  " + pj);
    if (pj.contains("挂件")) {
      this.ts = "and t like '%挂件'";
      this.guajian = true;
      this.btnCreate.setVisible(true);
    } 
    System.out.println("挂件标识：" + this.guajian);
    if ("root".equals(Code.USER.getProduction())) {
      label_orno.setVisible(true);
      this.textField_orno.setVisible(true);
      label_pono.setVisible(true);
      this.textField_pono.setVisible(true);
      label_cprj.setVisible(true);
      this.textField_cprj.setVisible(true);
      this.btn_ornoSearch.setVisible(true);
    } 
    setBounds(0, 0, 1584, 841);
    this.btnCreate.addMouseListener((MouseListener)new Object(this, table1, disposableText, arrangeText, progressBar, (DefaultTableModel)object1));
    this.btnPrintSearch.addMouseListener((MouseListener)new Object(this, table1, disposableText, arrangeText));
    this.btnNewButton2.addMouseListener((MouseListener)new Object(this, progressBar, table1, (DefaultTableModel)object1, frame, disposableText, arrangeText));
    table1.addMouseListener((MouseListener)new Object(this, table1, (DefaultTableModel)object1, disposableText, arrangeText));
  }
  
  public String operaSql(String sql) {
    String product = Code.USER.getProduct();
    String[] ps = null;
    if (StringUtils.isNotBlank(product))
      ps = product.split(","); 
    if (null != ps && ps.length > 0)
      for (int i = 0; i < ps.length; i++) {
        if (StringUtils.isNotBlank(ps[i])) {
          if (i == 0) {
            sql = sql + " AND ( PRODUCT= '" + ps[i] + "'";
          } else {
            sql = sql + " OR PRODUCT= '" + ps[i] + "'";
          } 
          if (i == ps.length - 1)
            sql = sql + " ) "; 
        } 
      }  
    return sql;
  }
  
  public String operaSqlNew(String sql) {
    String product = Code.USER.getProduct();
    String[] ps = null;
    if (StringUtils.isNotBlank(product))
      ps = product.split(","); 
    if (null != ps && ps.length > 0)
      for (int i = 0; i < ps.length; i++) {
        if (StringUtils.isNotBlank(ps[i])) {
          if (i == 0) {
            sql = sql + " AND ( PRODUCT= '" + ps[i] + "'";
          } else {
            sql = sql + " OR PRODUCT= '" + ps[i] + "'";
          } 
          if (i == ps.length - 1)
            sql = sql + " ) "; 
        } 
      }  
    return sql;
  }
  
  public String createSqlInCondition(String[] arr) {
    arr = (String[])Arrays.<String>stream(arr).filter(e -> StringUtils.isNotBlank(e)).toArray(x$0 -> new String[x$0]);
    StringBuilder sqlBuilder = new StringBuilder();
    sqlBuilder.append("(");
    for (int i = 0; i < arr.length; i++) {
      sqlBuilder.append("'").append(arr[i]).append("'");
      if (i < arr.length - 1)
        sqlBuilder.append(", "); 
    } 
    sqlBuilder.append(")");
    return sqlBuilder.toString();
  }
  
  private void initializeV7New(String sql, String filterSQL) {
    System.out.println("在线打印->V7表数据初始化，请等待...");
    System.out.println("在线打印-> initializeV7 参数1：" + sql);
    System.out.println("在线打印-> initializeV7 参数2：" + filterSQL);
    try {
      this.v7List = initializeV7Tab(sql);
      this.isInitializedV7 = true;
      System.out.println("在线打印->V7表数据初始化完成！");
      System.out.println("在线打印->成功加载v7表数据：" + this.v7List.size() + "条");
    } catch (Exception exp) {
      System.out.println("在线打印->V7表数据初始化异常" + exp.getMessage());
      exp.printStackTrace();
    } finally {
      if (Objects.nonNull(this.waitUtil))
        this.waitUtil.dispose(); 
    } 
  }
  
  private ArrayList<V7Model> initializeV7Tab(String sql) {
    System.out.println("initializeV7Tab 加载欧盟订单的数据sql:" + sql);
    ArrayList<V7Model> v7List = new ArrayList<>();
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      ResultSet rs = stat.executeQuery(sql);
      while (rs.next()) {
        String itemfromv7 = rs.getString("T$ITEM");
        String ornofromv7 = rs.getString("T$ORNO");
        String ponofromv7 = rs.getString("T$PONO");
        String dscefromv7 = rs.getString("T$DSCA");
        String titemfromv7 = rs.getString("TITEM");
        String tdscefromv7 = rs.getString("TDSCA");
        String customerIDfromv7 = rs.getString("T$CUNO");
        String nldfromv7 = rs.getString("T$EURO");
        String nld2fromv7 = rs.getString("T$PACR");
        String ladderNofromv7 = null;
        String ladderNoExcel = rs.getString("T$ELNP");
        String country = rs.getString("T$EQNO");
        String zxbz = rs.getString("ZXBZ");
        if (ladderNoExcel.contains(" ")) {
          ladderNofromv7 = ladderNoExcel.substring(0, ladderNoExcel.indexOf(" "));
        } else {
          ladderNofromv7 = ladderNoExcel;
        } 
        V7Model v7 = new V7Model();
        v7.setCustomerID(customerIDfromv7);
        v7.setDsce(dscefromv7);
        v7.setItem(itemfromv7);
        v7.setNld(nldfromv7);
        v7.setOrno(ornofromv7);
        v7.setPono(ponofromv7);
        v7.setTdsce(tdscefromv7);
        v7.setTitem(titemfromv7);
        v7.setLadderNo(ladderNofromv7);
        v7.setNld2(nld2fromv7);
        v7.setCountry(country);
        v7.setZxbz(zxbz);
        v7List.add(v7);
      } 
      rs.close();
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    return v7List;
  }
  
  private String mergeSQL(String baseSQL) {
    int[] selectedRows = this.scrollPane.table.getSelectedRows();
    StringBuilder sql = new StringBuilder(baseSQL);
    if (selectedRows.length == 0)
      return sql.toString(); 
    for (int i = 0; i < selectedRows.length; i++) {
      String orno = (String)this.scrollPane.table.getValueAt(selectedRows[i], 1);
      String pono = (String)this.scrollPane.table.getValueAt(selectedRows[i], 2);
      sql.append("(T$ORNO='").append(orno).append("' AND T$PONO='").append(pono).append("')");
      if (i < selectedRows.length - 1)
        sql.append(" OR "); 
    } 
    System.out.println(sql.toString());
    return sql.toString();
  }
  
  private String getFilterSQL() {
    int[] selectedRows = this.scrollPane.table.getSelectedRows();
    StringBuilder sql = new StringBuilder("AND (");
    if (selectedRows.length == 0)
      return sql.toString(); 
    for (int i = 0; i < selectedRows.length; i++) {
      String orno = (String)this.scrollPane.table.getValueAt(selectedRows[i], 1);
      String pono = (String)this.scrollPane.table.getValueAt(selectedRows[i], 2);
      sql.append(" (ORNO='").append(orno).append("' AND PONO='").append(pono).append("')");
      if (i < selectedRows.length - 1)
        sql.append(" OR "); 
    } 
    sql.append(")");
    System.out.println(sql.toString());
    return sql.toString();
  }
  
  private String getAutoSelectAllSQL(JTable table) {
    int[] selectedRows = table.getSelectedRows();
    StringBuilder sql = new StringBuilder("");
    if (selectedRows.length == 0)
      return sql.toString(); 
    sql.append(" (");
    for (int i = 0; i < selectedRows.length; i++) {
      String orno = (String)table.getValueAt(selectedRows[i], 10);
      String pono = (String)table.getValueAt(selectedRows[i], 11);
      sql.append(" (b.ORNO='").append(orno).append("' AND b.PONO='").append(pono).append("')");
      if (i < selectedRows.length - 1)
        sql.append(" OR "); 
    } 
    sql.append(")");
    System.out.println(sql.toString());
    return sql.toString();
  }
  
  private String getAfterCheckGeneralSQL(List<Hanger> list) {
    StringBuilder sql = new StringBuilder("");
    if (list.size() == 0)
      return sql.toString(); 
    sql.append(" (");
    for (int i = 0; i < list.size(); i++) {
      Hanger hanger = list.get(i);
      String orno = hanger.getOrNo();
      String pono = hanger.getPoNo();
      sql.append(" (b.ORNO='").append(orno).append("' AND b.PONO='").append(pono).append("')");
      if (i < list.size() - 1)
        sql.append(" OR "); 
    } 
    sql.append(")");
    System.out.println(sql.toString());
    return sql.toString();
  }
  
  private void getLabelDataNew(String filterSQL) {
    List<Hanger> hangerList = getHangerList(filterSQL);
    System.out.println("getHangerList列表数量：" + hangerList.size());
    initializeTable(hangerList);
  }
  
  private int filterRefuseData(Hanger hanger) {
    hanger = getFeatureValues(hanger);
    String itemStr = hanger.getItem();
    String dsceStr = hanger.getDsce();
    String saleOrNoStr = hanger.getOrNo();
    String poNoStr = hanger.getPoNo();
    String doorType = hanger.getDoorType();
    String doorOpeningWidth = hanger.getDoorOpeningWidth();
    String railingType = hanger.getRailingType();
    String panelInterface = hanger.getPanelInterface();
    String railingInterface = hanger.getRailingInterface();
    String elevatorRegulation = hanger.getElevatorRegulation();
    String couplerPosition = hanger.getCouplerPosition();
    String emergencyOpeningDevice = hanger.getEmergencyOpeningDevice();
    String fhdj = hanger.getLevel();
    String a = hanger.getA();
    String b = hanger.getB();
    String isOm = "否";
    if (this.aList.contains(a) && this.bList.contains(b))
      isOm = "是"; 
    this.printDataList = null;
    this.printDataList = SourceData.getData(new String[] { itemStr, dsceStr, saleOrNoStr, poNoStr }, this.v7List, doorType, doorOpeningWidth, railingType, panelInterface, railingInterface, elevatorRegulation, couplerPosition, emergencyOpeningDevice, fhdj, isOm);
    int listSize = 0;
    if (this.printDataList == null || (listSize = this.printDataList.size()) == 0) {
      System.out.println("printDataList" + ((this.printDataList == null) ? 1 : 0));
      System.out.println("printDataList" + this.printDataList);
      System.out.println("数据无法正常读取直接忽略>>> 订单号：" + saleOrNoStr + "  订单行：" + poNoStr);
      return 9;
    } 
    int type = Integer.parseInt(this.printDataList.get(listSize - 1));
    return type;
  }
  
  private List<Hanger> getHangerList(String filterSQL) {
    List<Hanger> hangerList = new ArrayList<>();
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "SELECT ID, BOXID, ITEM, DSCE, ORNO, PONO, CODE, PYNDATE, STATE, STATION, NINECODE, SNO,ORDERZ,SEQNUM,TID,TNAME,CPRJ,PAGE  FROM cbarcode_PENDANT_ONLINE WHERE STATE = '1' " + filterSQL + " ORDER BY ID";
      ResultSet rs = stat.executeQuery(sql);
      Hanger hanger = null;
      System.out.println("查询已生成待打印记录sql：" + sql);
      while (rs.next()) {
        hanger = new Hanger();
        hanger.setID(rs.getInt("ID"));
        hanger.setBoxId(rs.getString("BOXID"));
        hanger.setItem(rs.getString("ITEM"));
        hanger.setDsce(rs.getString("DSCE"));
        hanger.setOrNo(rs.getString("ORNO"));
        hanger.setPoNo(rs.getString("PONO"));
        hanger.setCode(rs.getString("CODE"));
        hanger.setPynDate(rs.getString("PYNDATE"));
        hanger.setState(rs.getInt("STATE"));
        hanger.setStation(rs.getString("STATION"));
        hanger.setNineCode(rs.getString("NINECODE"));
        hanger.setSno(rs.getString("SNO"));
        hanger.setOrderZ(rs.getString("ORDERZ"));
        hanger.setSeqnum(rs.getString("SEQNUM"));
        hanger.setTid(rs.getInt("TID"));
        hanger.setTname(rs.getString("TNAME"));
        hanger.setCprj(rs.getString("CPRJ"));
        hanger.setPage(Integer.valueOf(rs.getInt("PAGE")));
        hangerList.add(hanger);
      } 
      rs.close();
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    return hangerList;
  }
  
  private void initializeTable(List<Hanger> list) {
    List<String> aList = Arrays.asList(new String[] { "AU", "EU", "MY", "OT" });
    List<String> bList = Arrays.asList(new String[] { "1", "3", "EN81-20", "EN81-70", "EN81-71", "EN81-72" });
    Object[][] data = new Object[list.size()][26];
    for (int i = 0; i < list.size(); i++) {
      data[i][0] = ((Hanger)list.get(i)).getSeqnum();
      data[i][1] = ((Hanger)list.get(i)).getOrNo();
      data[i][2] = ((Hanger)list.get(i)).getItem();
      data[i][3] = ((Hanger)list.get(i)).getPoNo();
      data[i][4] = ((Hanger)list.get(i)).getBoxId();
      data[i][5] = ((Hanger)list.get(i)).getDsce();
      data[i][6] = ((Hanger)list.get(i)).getCode();
      data[i][7] = ((Hanger)list.get(i)).getNineCode();
      data[i][8] = Integer.valueOf(((Hanger)list.get(i)).getID());
      data[i][9] = ((Hanger)list.get(i)).getSno();
      data[i][10] = ((Hanger)list.get(i)).getStation();
      data[i][11] = ((Hanger)list.get(i)).getOrderZ();
      data[i][12] = Integer.valueOf(((Hanger)list.get(i)).getTid());
      data[i][13] = ((Hanger)list.get(i)).getTname();
      data[i][14] = ((Hanger)list.get(i)).getCprj();
      data[i][15] = String.format("%03d", new Object[] { ((Hanger)list.get(i)).getPage() });
      Map<String, String> map = v7MapData();
      if (map.containsKey(((Hanger)list.get(i)).getOrNo() + "&" + ((Hanger)list.get(i)).getPoNo()) && !((Hanger)list.get(i)).getTname().contains("AMD"))
        data[i][25] = "是"; 
      if (((Hanger)list.get(i)).getTname().contains("AMD"))
        try {
          Connection conn = OracleUtils.getConnection();
          Statement stat = conn.createStatement();
          String sql = "select get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 10) as doorType ,  get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 11) as doorOpeningWidth,  get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 18) as railingType,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,160) as panelInterface,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,19) as railingInterface,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,88) as elevatorRegulation,    get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,202) as couplerPosition,    get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,26) as emergencyOpeningDevice, case when get_pcffeaturenew('WJ','comjxg',t$orno,t$pono,23)='IP54' then  '-IP54' else ' ' end 防护等级, get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 2) as a, get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 88) as b   from ttdsls041220     where t$orno = " + ((Hanger)list.get(i)).getOrNo() + " and t$pono =" + ((Hanger)list.get(i)).getPoNo();
          ResultSet rs = stat.executeQuery(sql);
          Hanger hanger = null;
          System.out.println("online ComponetCodePrint 3215 查询特性：" + sql);
          while (rs.next()) {
            data[i][16] = rs.getString("doorType");
            data[i][17] = rs.getString("doorOpeningWidth");
            data[i][18] = rs.getString("railingType");
            data[i][19] = rs.getString("panelInterface");
            data[i][20] = rs.getString("railingInterface");
            data[i][21] = rs.getString("elevatorRegulation");
            data[i][22] = rs.getString("couplerPosition");
            data[i][23] = rs.getString("emergencyOpeningDevice");
            data[i][24] = rs.getString("防护等级");
            String a = rs.getString("a");
            String b = rs.getString("b");
            if (aList.contains(a) && bList.contains(b)) {
              data[i][25] = "是";
              continue;
            } 
            data[i][25] = "否";
          } 
          rs.close();
          stat.close();
          conn.close();
        } catch (Exception e) {
          e.printStackTrace();
        }  
    } 
    this.scrollPane.tablecontent = new DefaultTableModel(data, (Object[])this.scrollPane.titles_om);
    this.scrollPane.table.setModel(this.scrollPane.tablecontent);
    RowSorter<TableModel> sorter = new TableRowSorter<>(this.scrollPane.tablecontent);
    List<RowSorter.SortKey> sortKeys = new ArrayList<>();
    sortKeys.add(new RowSorter.SortKey(14, SortOrder.ASCENDING));
    sortKeys.add(new RowSorter.SortKey(15, SortOrder.ASCENDING));
    sorter.setSortKeys(sortKeys);
    this.scrollPane.table.setRowSorter(sorter);
    DefaultTableCellRenderer render = new DefaultTableCellRenderer();
    render.setHorizontalAlignment(0);
    this.scrollPane.table.getColumnModel().getColumn(0).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(1).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(2).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(3).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(4).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(5).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(6).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(7).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(8).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(9).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(10).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(11).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(12).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(13).setCellRenderer(render);
    this.scrollPane.table.getColumnModel().getColumn(0).setPreferredWidth(50);
    this.scrollPane.table.getColumnModel().getColumn(1).setPreferredWidth(100);
    this.scrollPane.table.getColumnModel().getColumn(2).setPreferredWidth(150);
    this.scrollPane.table.getColumnModel().getColumn(3).setPreferredWidth(50);
    this.scrollPane.table.getColumnModel().getColumn(4).setPreferredWidth(150);
    this.scrollPane.table.getColumnModel().getColumn(5).setPreferredWidth(120);
    this.scrollPane.table.getColumnModel().getColumn(6).setPreferredWidth(350);
    this.scrollPane.table.getColumnModel().getColumn(7).setPreferredWidth(100);
    this.scrollPane.table.getColumnModel().getColumn(8).setPreferredWidth(75);
    this.scrollPane.table.getColumnModel().getColumn(9).setPreferredWidth(100);
    this.scrollPane.table.getColumnModel().getColumn(10).setPreferredWidth(75);
    this.scrollPane.table.getColumnModel().getColumn(11).setPreferredWidth(75);
    this.scrollPane.table.getColumnModel().getColumn(12).setPreferredWidth(75);
    this.scrollPane.table.getColumnModel().getColumn(13).setPreferredWidth(75);
    this.scrollPane.table.updateUI();
    this.scrollPane.table.selectAll();
    System.out.println(this.scrollPane.table.getRowCount());
  }
  
  public Map<String, String> v7MapData() {
    Map<String, String> map = new HashMap<>();
    if (this.v7List != null)
      for (V7Model model : this.v7List) {
        if (model.getNld().equals("是") && model.getNld2().contains("发往欧盟"))
          map.put(model.getOrno() + "&" + model.getPono(), ""); 
      }  
    return map;
  }
  
  public void setTabelModelHeader(String[] titles, boolean om) {
    this.scrollPane.tablecontent.setRowCount(0);
    this.scrollPane.tablecontent.setColumnIdentifiers((Object[])titles);
    this.scrollPane.table.getColumnModel().getColumn(0).setCellRenderer((TableCellRenderer)new Object(this));
    this.scrollPane.repaint();
  }
  
  protected void setAsPrinted(String idStr) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "update cbarcode_pendant_online set STATE = 3 where ID = '" + idStr + "'";
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected void updateBoxPrint(String idStr, String kmcd) {
    System.out.println("KM挂件打印 updateBoxPrint idStr" + idStr + " kmcd " + kmcd);
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String boxprintSQL1 = "update cbarcode_boxprint bp inner join cbarcode_pendant_online po on bp.code=po.code set bp.km='" + kmcd + "' where po.id= " + idStr + " and bp.cause is null";
      String boxprintSQL = "update cbarcode_boxprint set km='" + kmcd + "' where code in (select code from cbarcode_pendant_online where id= " + idStr + ") and cause is null";
      System.out.println("updateBoxPrint boxprintSQL:" + boxprintSQL);
      stat.executeUpdate(boxprintSQL);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected Hanger getFeatureValues(Hanger hanger) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "select get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 10) as doorType ,  get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 11) as doorOpeningWidth,  get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 18) as railingType,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,160) as panelInterface,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,19) as railingInterface,   get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,88) as elevatorRegulation,    get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,202) as couplerPosition,    get_pcffeaturenewvalue('WJ','comjxg',t$orno,t$pono,26) as emergencyOpeningDevice, case when get_pcffeaturenew('WJ','comjxg',t$orno,t$pono,23)='IP54' then  '-IP54' else ' ' end 防护等级, get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 2) as a, get_pcffeaturenewvalue('WJ', 'comjxg', t$orno, t$pono, 88) as b   from ttdsls041220     where t$orno = " + hanger.getOrNo() + " and t$pono =" + hanger.getPoNo();
      ResultSet rs = stat.executeQuery(sql);
      System.out.println("online ComponetCodePrint 3363 查询特性：" + sql);
      while (rs.next()) {
        hanger.setDoorType(rs.getString("doorType"));
        hanger.setDoorOpeningWidth(rs.getString("doorOpeningWidth"));
        hanger.setRailingType(rs.getString("railingType"));
        hanger.setPanelInterface(rs.getString("railingInterface"));
        hanger.setRailingInterface(rs.getString("railingInterface"));
        hanger.setElevatorRegulation(rs.getString("elevatorRegulation"));
        hanger.setCouplerPosition(rs.getString("couplerPosition"));
        hanger.setEmergencyOpeningDevice(rs.getString("emergencyOpeningDevice"));
        hanger.setLevel(rs.getString("防护等级"));
        hanger.setA(rs.getString("a"));
        hanger.setB(rs.getString("b"));
      } 
      rs.close();
      stat.close();
      conn.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return hanger;
  }
  
  protected void setAsNoPrinted(String idStr) {
    try {
      OracledbUtil outil = new OracledbUtil();
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "SELECT ID, BOXID, ITEM, ORNO, PONO, cprj,DSCE FROM cbarcode_pendant_online where ID = '" + idStr + "'";
      ResultSet rs = stat.executeQuery(sql);
      System.out.println("pendantonline sql：" + sql);
      String boxid = "";
      String item = "";
      String dsce = "";
      String orno = "";
      String pono = "";
      String cprj = "";
      while (rs.next()) {
        int id = rs.getInt("ID");
        boxid = rs.getString("BOXID");
        item = rs.getString("ITEM");
        dsce = rs.getString("DSCE");
        orno = rs.getString("ORNO");
        pono = rs.getString("PONO");
        cprj = rs.getString("CPRJ");
      } 
      System.out.println("pendantonline query:" + boxid + " " + item + " " + orno + " " + pono + " " + cprj);
      String sql1 = "update cbarcode_pendant_online set STATE = 5 where ID = '" + idStr + "'";
      stat.executeUpdate(sql1);
      stat.close();
      conn.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public void updateBoxListIspyn(String xmh, String boxid, String wlh, String orno, String pono) {
    String updateboxlist = "";
    if (xmh.equals("000000")) {
      updateboxlist = "update CBarcode_BoxList set ispyn=1 where ispyn=0 and boxid='" + boxid + "' and item='" + wlh + "' and orno='" + orno + "' and pono='" + pono + "'";
    } else {
      updateboxlist = "update CBarcode_BoxList set ispyn=1 where ispyn=0 and boxid='" + boxid + "' and item='" + wlh + "' and cprj = '" + xmh + "' and orno='" + orno + "' and pono='" + pono + "'";
    } 
    System.out.println(updateboxlist);
    try {
      OracledbUtil outil = new OracledbUtil();
      System.out.println("更新开始：" + (new SimpleDateFormat("yyyy-MM-dd hh:mm:ss")).format(new Date()));
      outil.pst = outil.conn.prepareStatement(updateboxlist);
      outil.pst.executeUpdate();
      System.out.println("更新结束：" + (new SimpleDateFormat("yyyy-MM-dd hh:mm:ss")).format(new Date()));
      outil.close();
    } catch (SQLException e1) {
      e1.printStackTrace();
      System.out.println("物料打印状态更新失败!");
    } 
  }
  
  public void delUnPrintRecords() {
    Connection conn = null;
    Statement state = null;
    try {
      conn = OracleUtils.getConnection();
      state = conn.createStatement();
      String querySQL = "DELETE FROM CBARCODE_PENDANT_ONLINE WHERE STATE = 1 AND STATION in (" + this.stations + ")";
      System.out.println("delUnPrintRecords sql:" + querySQL);
      int countDone = state.executeUpdate(querySQL);
      System.out.println("删除本岗位已生成未打印的记录:" + countDone);
      OracleUtils.close(null, state, conn);
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  protected void saveWitturCEData(String certStr, String seriesStr, String serialNoStr, String saleOrNoStr, String poNoStr, String itemStr, String codeStr, String boxIdStr, String dsceStr, String typeStr) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "insert into cbarcode_witturce (certificateno, series, serialnumber, orno, pono, item, code, boxid, dsce, type, pdate) values('" + certStr + "', '" + seriesStr + "', '" + serialNoStr + "', '" + saleOrNoStr + "', '" + poNoStr + "', '" + itemStr + "', '" + codeStr + "', '" + boxIdStr + "', '" + dsceStr + "', '" + typeStr + "', sysdate) ";
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected void saveWitturCEAndSchindlerData(String materialStr, String idNoStr, String serialNoStr, String saleOrNoStr, String poNoStr, String itemStr, String codeStr, String codeStr2, String boxIdStr, String dsceStr, String nld, String certStr, String seriesStr, String typeStr) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "insert into cbarcode_witturceandschindler (materialdes, idnumber, serialnumber, orno, pono, item, witturcecode, schindlercode, boxid, dsce, nld, certificateno, series, type, pdate) values('" + materialStr + "', '" + idNoStr + "', '" + serialNoStr + "', '" + saleOrNoStr + "', '" + poNoStr + "', '" + itemStr + "', '" + codeStr + "', '" + codeStr2 + "', '" + boxIdStr + "', '" + dsceStr + "','" + nld + "', '" + certStr + "', '" + seriesStr + "', '" + typeStr + "', sysdate) ";
      System.out.println(sql);
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected void saveAMDAndBarcodeData(String productCode, String type, String serialNoStr, String saleOrNoStr, String poNoStr, String itemStr, String codeStr, String barcodeStr, String boxIdStr, String dsceStr, String certNo, String baseIDStr, String partsStr, String updateCodeStr, String supplierCodeStr, String ladderNo) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "insert into cbarcode_amdandbarcode (productcode, componenttype, serialnumber, orno, pono, item, amdcode, barcode, boxid, dsce, certificatnum, baseid, parts, updatecode, suppliercode, ladderNo, pdate) values('" + productCode + "', '" + type + "', '" + serialNoStr + "', '" + saleOrNoStr + "', '" + poNoStr + "', '" + itemStr + "', '" + codeStr + "', '" + barcodeStr + "', '" + boxIdStr + "', '" + dsceStr + "','" + certNo + "', '" + baseIDStr + "', '" + partsStr + "', '" + updateCodeStr + "', '" + supplierCodeStr + "', '" + ladderNo + "', sysdate) ";
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected void saveWitturCEAndBarcodeData(String certStr, String seriesStr, String serialNoStr, String saleOrNoStr, String poNoStr, String itemStr, String codeStr, String barcode, String boxIdStr, String dsceStr, String typeStr, String baseIDStr, String partsStr, String updateCodeStr, String supplierCodeStr) {
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "insert into cbarcode_witturceandbarcode (certificateno, series, serialnumber, orno, pono, item, witturcecode, barcode, boxid, dsce, type, pdate, baseid, parts, updatecode, suppliercode) values('" + certStr + "', '" + seriesStr + "', '" + serialNoStr + "', '" + saleOrNoStr + "', '" + poNoStr + "', '" + itemStr + "', '" + codeStr + "', '" + barcode + "', '" + boxIdStr + "', '" + dsceStr + "', '" + typeStr + "', sysdate, '" + baseIDStr + "', '" + partsStr + "', '" + updateCodeStr + "', '" + supplierCodeStr + "') ";
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  protected void saveBarcodeAndQRCodeData(String baseIDStr, String partsStr, String updateCodeStr, String supplierCodeStr, String serialNoStr, String codeStr, String barcodeStr, String saleOrNoStr, String poNoStr, String boxIdStr, String itemStr, String dsceStr) {
    try {
      Connection conn = OracleUtils.getConnection();
      String sql = "insert into cbarcode_barcodeandqrcode (baseid, parts, updatecode, suppliercode, serialnumber, qrcode, barcode, orno, pono, boxid, item, dsce, pdate) values(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, sysdate)";
      PreparedStatement ps = conn.prepareStatement(sql);
      ps.setString(1, baseIDStr);
      ps.setString(2, partsStr);
      ps.setString(3, updateCodeStr);
      ps.setString(4, supplierCodeStr);
      ps.setString(5, serialNoStr);
      ps.setString(6, codeStr);
      ps.setString(7, barcodeStr);
      ps.setString(8, saleOrNoStr);
      ps.setString(9, poNoStr);
      ps.setString(10, boxIdStr);
      ps.setString(11, itemStr);
      ps.setString(12, dsceStr);
      ps.executeUpdate();
      ps.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
  }
  
  public List<String> getBakItemList() {
    List<String> bakItemlist = new ArrayList<>();
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "select * from ttiinc060220";
      ResultSet set = stat.executeQuery(sql);
      while (set.next()) {
        if (set.getString("T$ITEM") != null)
          bakItemlist.add(set.getString("T$ITEM").trim()); 
      } 
      set.close();
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    return bakItemlist;
  }
  
  public String getKMByItem(String item) {
    String km = "";
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "select * from ttiinc060220 where T$ITEM='" + item + "'";
      ResultSet set = stat.executeQuery(sql);
      while (set.next()) {
        if (set.getString("T$NOTE") != null)
          km = set.getString("T$NOTE").trim(); 
      } 
      set.close();
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    return km;
  }
  
  public String getDIMS(String boxId) {
    String dims = "";
    try {
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      String sql = "select dims from cbarcode_boxhead where boxid='" + boxId + "'";
      ResultSet set = stat.executeQuery(sql);
      while (set.next()) {
        if (set.getString("DIMS") != null)
          dims = set.getString("DIMS").trim(); 
      } 
      set.close();
      stat.close();
      conn.close();
    } catch (SQLException e) {
      e.printStackTrace();
      return dims;
    } 
    return dims;
  }
  
  public void setBoxHeadSend(String boxid) {
    try {
      String sql = "UPDATE CBARCODE_BOXHEAD SET SEND = 1 WHERE BOXID = '" + boxid + "'";
      Connection conn = OracleUtils.getConnection();
      Statement stat = conn.createStatement();
      stat.executeUpdate(sql);
      stat.close();
      conn.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public void updatePlanState(String planid, boolean isXD) {
    String sql = "update CBARCODE_ONLINEPLAN set finish_status=2 where id = '" + planid + "'";
    if (isXD)
      sql = "update CBARCODE_ONLINEPLAN set finish_status=2 where finish_status=0 and CUSTOMER_DESC like '%迅达%' and "; 
    System.out.println("updatePlanState修改排班计划的isXD：" + isXD);
    System.out.println("updatePlanState修改排班计划的sql：" + sql);
    OracledbUtil oracledbUtil = new OracledbUtil();
    oracledbUtil.ExecuteSQL(sql);
    oracledbUtil.close();
  }
  
  public void updatePlanState(String orno, String pono, JTable table1) {
    int[] table1Selecteds = table1.getSelectedRows();
    String ids = "";
    String id = "";
    String tempOrno = "";
    String tempPrno = "";
    for (int r : table1Selecteds) {
      id = (String)table1.getValueAt(r, 1);
      tempOrno = (String)table1.getValueAt(r, 10);
      tempPrno = (String)table1.getValueAt(r, 11);
      if (tempOrno.trim().equals(orno.trim()) && tempPrno.trim().equals(pono))
        ids = ids = ids + "'" + id + "',"; 
    } 
    if (!ids.equals(""))
      ids = ids.substring(0, ids.length() - 1); 
    String sql = "update CBARCODE_ONLINEPLAN set finish_status=2 where id in(" + ids + ")";
    System.out.println("修改排班计划状态为不打印的sql：" + sql);
    OracledbUtil oracledbUtil = new OracledbUtil();
    oracledbUtil.ExecuteSQL(sql);
    oracledbUtil.close();
  }
  
  public void updatePlanState(Map<String, String> map, JTable table1) {
    int[] table1Selecteds = table1.getSelectedRows();
    String ids = "";
    String id = "";
    String tempOrno = "";
    String tempPrno = "";
    String key = "";
    for (int r : table1Selecteds) {
      id = (String)table1.getValueAt(r, 1);
      tempOrno = (String)table1.getValueAt(r, 10);
      tempPrno = (String)table1.getValueAt(r, 11);
      key = tempOrno + tempPrno;
      if (map.containsKey(key) && tempPrno.equals(map.get(key)))
        ids = ids = ids + "'" + id + "',"; 
    } 
    if (!ids.equals("")) {
      ids = ids.substring(0, ids.length() - 1);
      String sql = "update CBARCODE_ONLINEPLAN set finish_status=2 where id in(" + ids + ")";
      System.out.println("修改排班计划状态为不打印的sql：" + sql);
      OracledbUtil oracledbUtil = new OracledbUtil();
      oracledbUtil.ExecuteSQL(sql);
      oracledbUtil.close();
    } 
    map.clear();
  }
}
